#include <stdio.h>
#include <sys/time.h>

int main(int argc, char ** argv, char ** envp)
{
  struct timezone	tz = {0, 0};
  time_t now;
  int offset, dst;

  if (argc != 1 && (argc != 2 || strcmp(argv[1], "-u")))
    {
      fprintf(stderr, "usage:\n%s [-u]\n", argv[0]);
      exit(-1);
    }

  if (argc == 2)
    if (settimeofday(NULL, &tz))
      perror("settimeofday(NULL, &0)");

  now = time(&now);

  /* offset should be positive (-> +24) */
  offset = gmtime(&now)->tm_hour - localtime(&now)->tm_hour + 24;

  dst = (offset*3600 - timezone) % 86400; /* 86k4 secs per day */
  if (dst == 82800) dst = -3600;
  else if (dst != 0)
    {
      fprintf(stderr, "Weird dst value: %d seconds !\n", dst);
      exit(1);
    }

  /* printf("offs = %d, timezone = %ld, dst = %d\n", offset, timezone, dst); */

  tz.tz_minuteswest = (timezone+dst) / 60;
  if (settimeofday(NULL, &tz))
    perror("settimeofday(NULL, tz)");
  return(0);
}
